﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;
using System.Xml.Serialization;

namespace FinalProject
{
    [Serializable]
    public class Coin : Collectible
    {
        private Vector3 mPivot;
        private float mRadius;
        private string mTexture;

        public Coin()
            : base()
        {

        }

        public Coin(Vector3 at, float radius, string texture, eCollectibleCondition condition, int level)
            : base("Coin", Properties.Resources.Coin, condition, level)
        {
            mPivot = at;
            mRadius = radius;
            mTexture = texture;
            UWB_PrimitiveCircle circle = new UWB_PrimitiveCircle();
            circle.setCenter(at);
            circle.setRadius(radius);
            circle.enableTexturing(true);
            circle.setTextureFileName(texture);

            setPrimitive(circle);
            mXFormInfo.setPivot(at);
        }

        #region Public Properties for XML Serialization

        [XmlElement("Pivot")]
        public Vector3 PivotXML
        {
            get
            {
                return mPivot;
            }
            set
            {
                mPivot = value;
            }
        }

        [XmlElement("Radius")]
        public float RadiusXML
        {
            get
            {
                return mRadius;
            }
            set
            {
                mRadius = value;
            }
        }

        [XmlElement("Texture")]
        public string TextureXML
        {
            get
            {
                return mTexture;
            }
            set
            {
                mTexture = value;
            }
        }

        #endregion
    }
}
