﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;
using System.Xml.Serialization;

namespace FinalProject
{
    [Serializable]
    public class Net : UWB_SceneNode
    {
        private Vector3 pivot;
        private float netLength;
        private float netWidth;

        public Net()
            : base()
        {

        }

        public Net(Vector3 at, float netLength, float netWidth)
        {
            mName = "Net";

            this.pivot = at;
            this.netLength = netLength;
            this.netWidth = netWidth;

            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            Color netColor = new Color(120, 120, 120);

            UWB_PrimitiveRectangle net = new UWB_PrimitiveRectangle();
            net.setCorners(new Vector3(at.X - (netWidth/2), at.Y - netLength, 0),
                             new Vector3(at.X + (netWidth / 2), at.Y, 0));
            net.setFlatColor(netColor);
            net.setShadeMode(eShadeMode.smFlat);
            pList.append(net);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);
        }

        #region Public Properties for XML Serialization

        [XmlElement("Pivot")]
        public Vector3 PivotXML
        {
            get
            {
                return this.pivot;
            }
            set
            {
                this.pivot = value;
            }
        }

        [XmlElement("NetLength")]
        public float NetLengthXML
        {
            get
            {
                return this.netLength;
            }
            set
            {
                this.netLength = value;
            }
        }

        [XmlElement("NetWidth")]
        public float NetWidthXML
        {
            get
            {
                return this.netWidth;
            }
            set
            {
                this.netWidth = value;
            }
        }

        #endregion
    }
}
