﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class Arm : UWB_SceneNode
    {
        public Arm()
            : base()
        {

        }

        public Arm(Vector3 at, float armHeight, float armWidth, string name)
            : base(name)
        {
            UWB_PrimitiveList pList = new UWB_PrimitiveList();
            Color wetSuitColor = new Color(0, 0, 0);

            UWB_PrimitiveRectangle arm = new UWB_PrimitiveRectangle();
            arm.setCorners(new Vector3(at.X - (armWidth / 2), at.Y - armHeight, 0),
                           new Vector3(at.X + (armWidth / 2), at.Y, 0));
            arm.setFlatColor(wetSuitColor);
            arm.setShadeMode(eShadeMode.smFlat);
            pList.append(arm);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);

            Vector3 handAt = new Vector3(at.X, at.Y - armHeight, 0);
            UWB_SceneNode hand = new Hand(handAt, armHeight, armWidth);
            insertChildNode(hand);
        }
    }
}
