﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class Flipper : UWB_SceneNode
    {
        public Flipper()
            : base()
        {

        }

        public Flipper(Vector3 at, float footWidth, float footHeight)
        {
            mName = "Flipper";

            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            Color flipperColor = new Color(0, 0, 255);

            float flipperThickness = footWidth * .3f;
            Vector3 leftPoint = new Vector3(at.X - (footWidth / 2) - flipperThickness, at.Y, 0);
            Vector3 rightPoint = new Vector3(at.X + (footWidth / 2) + flipperThickness, at.Y, 0);
            Vector3 bottomPoint = new Vector3(at.X, at.Y - (footHeight * 1.35f), 0);

            UWB_PrimitiveTriangle flipper = new UWB_PrimitiveTriangle();
            flipper.setBottomLeftPoint(leftPoint.X, leftPoint.Y, leftPoint.Z);
            flipper.setBottomRightPoint(rightPoint.X, rightPoint.Y, rightPoint.Z);
            flipper.setTopPoint(bottomPoint.X, bottomPoint.Y, bottomPoint.Z);
            flipper.setFlatColor(flipperColor);
            flipper.setShadeMode(eShadeMode.smFlat);
            pList.append(flipper);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);
        }
    }
}
