﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class Foot : UWB_SceneNode
    {
        public Foot()
            : base()
        {

        }

        public Foot(Vector3 at, float legHeight)
        {
            mName = "Foot";

            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            float footHeight = legHeight * 1.5f;
            float footWidth = legHeight / 3f;

            Color skinColor = new Color(238, 171, 121);
            Color wetSuitColor = new Color(0, 0, 0);

            float footTopY = at.Y + (legHeight / 2);

            UWB_PrimitiveRectangle foot = new UWB_PrimitiveRectangle();
            foot.setCorners(new Vector3(at.X - footWidth, footTopY, 0),
                            new Vector3(at.X, footTopY - footHeight, 0));
            foot.setFlatColor(skinColor);
            foot.setTextureFileName("human_skin");
            foot.setTextureScale(1.45f);
            foot.enableTexturing(true);
            foot.useTextureAspectRatio(true);
            foot.setShadeMode(eShadeMode.smFlat);
            pList.append(foot);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);

            Vector3 flipperAt = new Vector3(at.X - (footWidth / 2), footTopY - (footHeight * .7f), 0);
            UWB_SceneNode flipper = new Flipper(flipperAt, footWidth, footHeight);
            insertChildNode(flipper);
        }
    }
}
