﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class Hand : UWB_SceneNode
    {
        public Hand()
            : base()
        {

        }

        public Hand(Vector3 at, float armLength, float armWidth)
        {
            mName = "Hand";

            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            float handRadius = armWidth / 2;

            Color skinColor = new Color(238, 171, 121);
            Color wetSuitColor = new Color(0, 0, 0);

            UWB_PrimitiveCircle hand = new UWB_PrimitiveCircle();

            hand.setCenter(new Vector3(at.X, at.Y - handRadius, 0));
            hand.setRadius(handRadius);
            hand.setFlatColor(skinColor);
            hand.setTextureFileName("human_skin");
            hand.setTextureScale(1.33f);
            hand.enableTexturing(true);
            hand.setShadeMode(eShadeMode.smFlat);
            pList.append(hand);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);
        }
    }
}
