﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class Leg : UWB_SceneNode
    {
        public Leg()
            : base()
        {

        }

        public Leg(Vector3 at, float legHeight, float legWidth, string name)
            : base(name)
        {
            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            Color skinColor = new Color(238, 171, 121);
            Color wetSuitColor = new Color(0, 0, 0);

            UWB_PrimitiveRectangle leg = new UWB_PrimitiveRectangle();
            leg.setCorners(new Vector3(at.X - legWidth, at.Y - (legHeight / 2), 0),
                             new Vector3(at.X, at.Y + (legHeight / 2), 0));
            leg.setFlatColor(wetSuitColor);
            leg.setShadeMode(eShadeMode.smFlat);
            pList.append(leg);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);

            Vector3 footAt = new Vector3(at.X - legWidth, at.Y, 0);
            UWB_SceneNode foot = new Foot(footAt, legHeight);
            insertChildNode(foot);
        }
    }
}
