﻿using Microsoft.Xna.Framework;
using UWBGL_XNA_Lib13;
using System;

namespace FinalProject
{
    [Serializable]
    public class WeightBelt : UWB_SceneNode
    {
        public WeightBelt()
            : base()
        {

        }

        public WeightBelt(Vector3 at, float torsoWidth, float torsoHeight)
        {
            mName = "Weight Belt";

            UWB_PrimitiveList pList = new UWB_PrimitiveList();

            Color airTankColor = new Color(245, 238, 31);
            Color wetSuitColor = new Color(0, 0, 0);

            UWB_PrimitiveRectangle weightBelt = new UWB_PrimitiveRectangle();
            weightBelt.setCorners(new Vector3(at.X, at.Y - (torsoHeight / 2), 0),
                                  new Vector3(at.X + (torsoHeight / 6), at.Y + (torsoHeight / 2), 0));
            weightBelt.setFlatColor(airTankColor);
            weightBelt.setShadeMode(eShadeMode.smFlat);
            pList.append(weightBelt);

            setPrimitive(pList);
            mXFormInfo.setPivot(at);
        }
    }
}
