﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace FinalProject
{
    /// <summary>
    /// Simple wrapper class so you can only do so much.
    /// </summary>
    [Serializable]
    public class Inventory
    {
        private ItemList mItems = new ItemList();

        public Inventory()
        {

        }

        #region Public Properties for XML Serialization

        [XmlArray("ItemList")]
        public ItemList ItemListXML
        {
            get
            {
                return this.mItems;
            }
            set
            {
                this.mItems = value;
            }
        }

        #endregion

        public int getItemCount()
        {
            return mItems.Count;
        }

        public Item getItem(int index)
        {
            if (index < 0 || index >= mItems.Count)
                return null;
            else
                return mItems[index];
        }

        public Item getItemOfSameType(object obj)
        {
            Item output = null;

            if ((obj != null) && (this.mItems != null) && (this.mItems.Count > 0))
            {
                Type t = obj.GetType();

                for (int i = 0; i < this.mItems.Count; i++)
                {
                    if (this.mItems[i].GetType() == t)
                    {
                        output = this.mItems[i];
                        break;
                    }
                }
            }

            return output;
        }

        public void addItem(Item item)
        {
            mItems.addItem(item);
        }

        public Item removeItem(string name)
        {
            return mItems.removeItem(name);
        }

        public bool removeItem(Item item)
        {
            return mItems.Remove(item);
        }
    }
}
