﻿using System.Windows.Forms;
using NathanScott_Lib;
using System;
using UWBGL_XNA_Lib13;
using Microsoft.Xna.Framework;

namespace FinalProject.UserControls
{
    public partial class PrimitiveControls : UserControl
    {
        UWB_Primitive mPrimitive;
        public PrimitiveControls()
        {
            InitializeComponent();

            mPrimitive = null;
        }

        public void setPrimitive(UWB_Primitive primitive)
        {
            if (primitive == null)
                Visible = false;
            else
                Visible = true;

            mPrimitive = primitive;

            updateControl();
        }

        public void updateControl()
        {
            if (mPrimitive != null)
            {
                _cbVisibility.Checked = mPrimitive.isVisible();
                _cbBoundVolume.Checked = mPrimitive.isDrawingBoundingVolume();
                _cbShading.Checked = (mPrimitive.getShadeMode() == eShadeMode.smGouraud);
                _cbWireframe.Checked = (mPrimitive.getFillMode() == eFillMode.fmWireframe);
                _cbTexture.Checked = mPrimitive.isTexturingEnabled();
                _cbBlending.Checked = mPrimitive.isBlendingEnabled();
                _sldrScale.Value = mPrimitive.getTextureScale();

                if (_rbObjColor.Checked)
                {
                    _colorSlider.Value = mPrimitive.getFlatColor();
                }
                else if (_rbShadingColor.Checked)
                {
                    _colorSlider.Value = mPrimitive.getShadingColor();
                }
            }
        }

        private void _colorSlider_ValidColor(Color color)
        {
            if (mPrimitive != null)
            {
                if (_rbObjColor.Checked)
                {
                    mPrimitive.setFlatColor(_colorSlider.Value);
                }
                else if (_rbShadingColor.Checked)
                {
                    mPrimitive.setShadingColor(_colorSlider.Value);
                }
            }
        }

        private void _rbObjColor_CheckedChanged(object sender, EventArgs e)
        {
            updateControl();
        }

        private void _rbShadingColor_CheckedChanged(object sender, EventArgs e)
        {
            updateControl();
        }

        private void _cbShading_CheckedChanged(object sender, EventArgs e)
        {
            mPrimitive.setShadeMode(_cbShading.Checked ? eShadeMode.smGouraud : eShadeMode.smFlat);
        }

        private void _cbBoundVolume_CheckedChanged(object sender, EventArgs e)
        {
            mPrimitive.setDrawBoundingVolume(_cbBoundVolume.Checked);
        }

        private void _cbWireframe_CheckedChanged(object sender, EventArgs e)
        {
            mPrimitive.setFillMode(_cbWireframe.Checked ? eFillMode.fmWireframe : eFillMode.fmSolid);
        }

        private void _cbTexture_CheckedChanged(object sender, EventArgs e)
        {
            mPrimitive.enableTexturing(_cbTexture.Checked);
        }

        private void _cbBlending_CheckedChanged(object sender, EventArgs e)
        {
            mPrimitive.enableBlending(_cbBlending.Checked);
        }

        private void _sldrScale_TypeValidText(double value)
        {
            mPrimitive.setTextureScale((float)_sldrScale.Value);
        }
    }
}
