﻿using System;
using System.Windows.Forms;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib13;
using Microsoft.Xna.Framework;

namespace FinalProject
{
    public class HeroControlHandler : ModelControlHandler
    {
        #region Members

        #endregion

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="HeroControlHandler"/> class.
        /// </summary>
        public HeroControlHandler(Model model):base(model)
        {
        }

        #endregion

        #region Public Methods

        #endregion

        #region Event Service Methods

        /// <summary>
        /// Called when [mouse button].
        /// </summary>
        /// <param name="down">if set to <c>true</c> [down].</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
        public override void OnMouseButton(bool down, MouseEventArgs e)
        {
            Vector3 mousePosition_Device = Vector3.Zero;
            Vector3 mousePosition_World = Vector3.Zero;

            Model model = mModel as Model;

            if (mModel != null && GetMousePositions(e, out mousePosition_Device, out mousePosition_World))
            {
                model.setMouseInfo("Small View", new Vector2(e.X, e.Y), mousePosition_Device, mousePosition_World);

                if (down)
                {
                    switch (e.Button)
                    {
                        case MouseButtons.Left:
                            // shoot a spear
                            model.useEquppedItem();
                            break;
                        case MouseButtons.Middle:
                        case MouseButtons.None:
                        case MouseButtons.Right:
                        case MouseButtons.XButton1:
                        case MouseButtons.XButton2:
                        default:
                            // do nothing
                            break;
                    }
                }
            }
        }

        /// <summary>
        /// Raises the <see cref="E:MouseMove"/> event.
        /// </summary>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
        public override void OnMouseMove(MouseEventArgs e)
        {
            Vector3 mousePosition_Device = Vector3.Zero;
            Vector3 mousePosition_World = Vector3.Zero;

            Model model = mModel as Model;

            if (model != null && GetMousePositions(e, out mousePosition_Device, out mousePosition_World))
            {
                model.setMouseInfo("Small View", new Vector2(e.X, e.Y), mousePosition_Device, mousePosition_World);

                switch (e.Button)
                {
                    case MouseButtons.Left:
                    case MouseButtons.Middle:
                    case MouseButtons.None:
                    case MouseButtons.Right:
                    case MouseButtons.XButton1:
                    case MouseButtons.XButton2:
                    default:
                        // do nothing
                        break;
                }
            }

            //Aim where our mouse is pointing
            if(model != null)
                model.heroAimAt(mousePosition_World);
        }

        #endregion

        #region Private Methods

        #endregion
    }
}
