﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FinalProject.Windows;

namespace FinalProject
{
    public partial class BagWindow : InventoryForm
    {
        //Callbacks
        public delegate void BagCloseEventHanlder();

        public event BagCloseEventHanlder InventoryCloseCallback;

        private Hero mPerson = null;

        public BagWindow()
        {
            InitializeComponent();
        }

        public void ini(Hero person)
        {
            mPerson = person;

            updateTable(_tblInventory, person.Bag, onButtonCreated, false);
        }

        /// <summary>
        /// This is called each loop in the populate control so you can
        /// customize your button or whatever else you want to do each loop
        /// </summary>
        /// <param name="button">button to be customized</param>
        /// <param name="item">item to use to customize it with/it corresponds to</param>
        private void onButtonCreated(Button button, Item item)
        {
            //set the button callback
            button.Click += new EventHandler(this.onButtonClicked);

            //Customize our button
            button.BackgroundImage = item.PreviewImage;
            button.BackgroundImageLayout = ImageLayout.Zoom;

            Model model = Program.getModel();
            string txt = item.getName();
            if ((model != null) && (model.GameDifficulty == eGameDifficulty.Easy) && (item is Collectible))
            {
                txt = string.Concat(txt, string.Format(": {0}", ((Collectible)(item)).Condition.ToString()));
            }
                //txt += ": $" + item.Price.ToString();

            button.Text = txt;
            button.TextAlign = ContentAlignment.BottomRight;
        }

        /// <summary>
        /// Called when a button is clicked
        /// </summary>
        /// <param name="sender">button instance that was clicked</param>
        /// <param name="e">other args</param>
        private void onButtonClicked(object sender, EventArgs e)
        {
        }

        private void _btDone_Click(object sender, EventArgs e)
        {
            if (this.InventoryCloseCallback != null)
                this.InventoryCloseCallback();

            Close();
        }
    }
}
