﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NathanScott_Lib
{
    /// <summary>
    /// A 2 point double or double vector2
    /// </summary>
    public class Point2D
    {
        /// <summary>
        /// x coordinate of the point
        /// </summary>
        public double x;

        /// <summary>
        /// y coordinate of the point
        /// </summary>
        public double y;

        /// <summary>
        /// Initialize x & y to 0.0
        /// </summary>
        public Point2D()
        {
            x = 0.0f;
            y = 0.0f;
        }

        /// <summary>
        /// Initialize x to xCord and y to yCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        public Point2D(double xCord, double yCord)
        {
            x = xCord;
            y = yCord;
        }

        /// <summary>
        /// Initialize x & y to val
        /// </summary>
        /// <param name="val">value to initialize x & y to</param>
        public Point2D(double val)
        {
            x = val;
            y = val;
        }
    }

    /// <summary>
    /// A 3 point double or double vector3
    /// </summary>
    public class Point3D
    {
        /// <summary>
        /// x coordinate of the point 
        /// </summary>
        public double x;

        /// <summary>
        /// y coordinate of the point 
        /// </summary>
        public double y;

        /// <summary>
        /// z coordinate of the point 
        /// </summary>
        public double z;

        /// <summary>
        /// Initialize x, y & z to 0.0
        /// </summary>
        public Point3D()
        {
            x = 0.0f;
            y = 0.0f;
            z = 0.0f;
        }

        /// <summary>
        /// Initialize x to xCord, y to yCord, and z to zCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        /// <param name="zCord">value for z</param>
        public Point3D(double xCord, double yCord, double zCord)
        {
            x = xCord;
            y = yCord;
            z = zCord;
        }

        /// <summary>
        /// Initialize x, y & z to val
        /// </summary>
        /// <param name="val">value to initialize x, y & z to</param>
        public Point3D(double val)
        {
            x = val;
            y = val;
            z = val;
        }
    }
}
