﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NathanScott_Lib
{
    /// <summary>
    /// A 2 point float or float vector 2
    /// </summary>
    public class Point2F
    {
        /// <summary>
        /// x coordinate of the point
        /// </summary>
        public float x;

        /// <summary>
        /// y coordinate of the point
        /// </summary>
        public float y;

        /// <summary>
        /// Initialize x & y to 0.0f
        /// </summary>
        public Point2F()
        {
            x = 0.0f;
            y = 0.0f;
        }

        /// <summary>
        /// Initialize x to xCord and y to yCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        public Point2F(float xCord, float yCord)
        {
            x = xCord;
            y = yCord;
        }

        /// <summary>
        /// Initialize x & y to val
        /// </summary>
        /// <param name="val">value to initialize x & y to</param>
        public Point2F(float val)
        {
            x = val;
            y = val;
        }
    }

    /// <summary>
    /// A 3 point float or float vector3
    /// </summary>
    public class Point3F
    {
        /// <summary>
        /// x coordinate of the point 
        /// </summary>
        public float x;

        /// <summary>
        /// y coordinate of the point 
        /// </summary>
        public float y;

        /// <summary>
        /// z coordinate of the point 
        /// </summary>
        public float z;

        /// <summary>
        /// Initialize x, y & z to 0.0f
        /// </summary>
        public Point3F()
        {
            x = 0.0f;
            y = 0.0f;
            z = 0.0f;
        }

        /// <summary>
        /// Initialize x to xCord, y to yCord, and z to zCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        /// <param name="zCord">value for z</param>
        public Point3F(float xCord, float yCord, float zCord)
        {
            x = xCord;
            y = yCord;
            z = zCord;
        }

        /// <summary>
        /// Initialize x, y & z to val
        /// </summary>
        /// <param name="val">value to initialize x, y & z to</param>
        public Point3F(float val)
        {
            x = val;
            y = val;
            z = val;
        }
    }
}
