﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NathanScott_Lib
{
    /// <summary>
    /// A 2 point integer or integer vector2
    /// </summary>
    public class Point2I
    {
        /// <summary>
        /// x coordinate of the point
        /// </summary>
        public int x;

        /// <summary>
        /// y coordinate of the point
        /// </summary>
        public int y;

        /// <summary>
        /// Initialize x & y to 0
        /// </summary>
        public Point2I()
        {
            x = 0;
            y = 0;
        }

        /// <summary>
        /// Initialize x to xCord and y to yCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        public Point2I(int xCord, int yCord)
        {
            x = xCord;
            y = yCord;
        }

        /// <summary>
        /// Initialize x & y to val
        /// </summary>
        /// <param name="val">value to initialize x & y to</param>
        public Point2I(int val)
        {
            x = val;
            y = val;
        }
    }

    /// <summary>
    /// A 3 point integer or integer vector3
    /// </summary>
    public class Point3I
    {
        /// <summary>
        /// x coordinate of the point 
        /// </summary>
        public int x;

        /// <summary>
        /// y coordinate of the point 
        /// </summary>
        public int y;

        /// <summary>
        /// z coordinate of the point 
        /// </summary>
        public int z;

        /// <summary>
        /// Initialize x, y & z to 0
        /// </summary>
        public Point3I()
        {
            x = 0;
            y = 0;
            z = 0;
        }

        /// <summary>
        /// Initialize x to xCord, y to yCord, and z to zCord
        /// </summary>
        /// <param name="xCord">value for x</param>
        /// <param name="yCord">value for y</param>
        /// <param name="zCord">value for z</param>
        public Point3I(int xCord, int yCord, int zCord)
        {
            x = xCord;
            y = yCord;
            z = zCord;
        }

        /// <summary>
        /// Initialize x, y & z to val
        /// </summary>
        /// <param name="val">value to initialize x, y & z to</param>
        public Point3I(int val)
        {
            x = val;
            y = val;
            z = val;
        }
    }
}
