using System;
using System.Collections.Generic;
using System.Data;
using System.Text;

namespace UWBGL_XNA_Lib13
{
    public class UWB_Clock
    {
        private DateTime m_previousUpdatetime;
        private bool mPaused = true;

        public UWB_Clock()
        {
            play();
        }

        public float getSecondsElapsed()
        {
            DateTime currentUpdateTime = DateTime.Now;
            TimeSpan elapsedTime = currentUpdateTime - m_previousUpdatetime;
            m_previousUpdatetime = currentUpdateTime;
            return (float)elapsedTime.TotalSeconds;
        }

        public TimeSpan getTimeElapsed()
        {
            DateTime currentUpdateTime = DateTime.Now;
            TimeSpan elapsedTime = currentUpdateTime - m_previousUpdatetime;
            m_previousUpdatetime = currentUpdateTime;
            return elapsedTime;
        }

        public void pause()
        {
            mPaused = true;
        }

        public void play()
        {
            if (mPaused)
            {
                m_previousUpdatetime = DateTime.Now;
                mPaused = false;
            }
        }

        public bool isPaused()
        {
            return mPaused;
        }
    }
}
