﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UWBGL_XNA_Lib13
{
    public class AnimationList : AnimationObject
    {
        private List<AnimationObject> mList = new List<AnimationObject>();

        public void add(AnimationObject animation)
        {
            mList.Add(animation);
        }

        public override bool isFinished()
        {
            return (mList.Count == 0);
        }

        public override void update(float elapsedSeconds)
        {
            int count = mList.Count;
            for (int i = count - 1; i >= 0; i--)
            {
                mList[i].update(elapsedSeconds);

                //If the animation is done remove it
                if (mList[i].isFinished())
                    mList.RemoveAt(i);
            }
        }
    }
}
