﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UWBGL_XNA_Lib13
{
    public class AnimationQue : AnimationObject
    {
        Queue<AnimationObject> mQue = new Queue<AnimationObject>();

        public override bool isFinished()
        {
            return (mQue.Count == 0);
        }

        public void add(AnimationObject info)
        {
            mQue.Enqueue(info);
        }

        public override void update(float elapsedSeconds)
        {
            AnimationObject animation = mQue.Peek();
            if (animation != null)
            {
                //Update the animation
                animation.update(elapsedSeconds);

                //If the animation is finished the remove the object
                if (animation.isFinished())
                    mQue.Dequeue();
            }
        }
    }
}
