using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace UWBGL_XNA_Lib13
{
    public class UWB_XNAWindowHandler:UWB_WindowHandler
    {
        protected GraphicsDevice m_XNA_GraphicsDevice;
        protected PresentationParameters pp;

        public override bool IsGraphicsDeviceValid()
        {
            return (m_XNA_GraphicsDevice != null);
        }

        public override bool InitializeHandler(IntPtr hAttachedWindow)
        {
            m_XNA_GraphicsDevice = null;
            pp = null;

            if (!base.InitializeHandler(hAttachedWindow))
                return false;

            UWB_XNAGraphicsSystem.m_TheAPI.CreateGraphicsContext(hAttachedWindow, ref pp);
            m_XNA_GraphicsDevice = UWB_XNAGraphicsSystem.m_TheAPI.GetActiveDevice();
            return true;
        }

		//nbowhay - Not sure if this is correct
        public override void ShutDownHandler()
        {
            base.ShutDownHandler();

            Control.FromHandle(m_hAttachedWindow).Dispose();
        }

        public override void BeginScene()
        {
            if (m_XNA_GraphicsDevice.GraphicsDeviceStatus == GraphicsDeviceStatus.Normal)
            {
                UWB_XNAGraphicsSystem.m_TheAPI.BeginScene(pp);
            }
        }

        public override void EndSceneAndShow()
        {
            if (m_XNA_GraphicsDevice.GraphicsDeviceStatus == GraphicsDeviceStatus.Normal)
                UWB_XNAGraphicsSystem.m_TheAPI.EndSceneAndShow(pp);
        }

        // Scott Loveless, 11.04.2010: - this was the original UWB library version.  I kept this in here just as a reference, and
        // in case we want to go back for some reason, but I fixed it for aspect ratio (below). 
        // 
        //public override void loadW2NDCXform()
        //{
        //    Matrix world2ndc;
        //    Matrix toSize;
        //    Matrix toPlace;

        //    Vector3 center = m_WCWindow.getCenter();

        //    toPlace = Matrix.CreateTranslation(-center);
        //    toSize = Matrix.CreateScale(2.0f / m_WCWindow.getWidth(), 2.0f / m_WCWindow.getHeight(), 1.0f);
        //    world2ndc = toPlace * toSize;

        //    UWB_XNAGraphicsSystem.m_TheAPI.setViewMatrix(world2ndc);
        //}

        /// <summary>
        /// Loads the w2 NDC xform.
        /// </summary>
        public override void loadW2NDCXform()
        {
            Matrix world2ndc;
            Matrix toSize;
            Matrix toPlace;

            Vector3 center = m_WCWindow.getCenter();

            float height = m_WCWindow.getHeight();
            float width = height * getAspectRatio();

            toPlace = Matrix.CreateTranslation(-center);
            //toSize = Matrix.CreateScale(2.0f / m_WCWindow.width(), 2.0f / m_WCWindow.height(), 1.0f);
            toSize = Matrix.CreateScale(2.0f / width, 2.0f / height, 1.0f);
            world2ndc = toPlace * toSize;

            UWB_XNAGraphicsSystem.m_TheAPI.setViewMatrix(world2ndc);
        }
    }
}
